/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <curl/curl.h>
#include "callbacks.h"
#include "gui.h"
#include "gnaughty.h"
#include "http.h"
#include "urls.h"
#include "parselinks.h"
#include "play.h"
#include "prefs.h"

static gpointer gnaughty_get_links_to_download(gpointer data);
static void gnaughty_show_downloaded_files(GList* LocalFileNames, gboolean movies);
static gboolean gnaughty_links_download_finished(gpointer data);
static gboolean gnaughty_set_download_status(gpointer data);
static gpointer gnaughty_download_and_process_index_page(gpointer data);
static gboolean gnaughty_index_download_finished(gpointer data);
static void gnaughty_do_download(gpointer data, gpointer user_data);
static gboolean gnaughty_download_finished(gpointer data);

GladeXML* GnaughtyXML = NULL;
GnaughtyPrefs g_prefs;
gnaughty_config key;
GList* g_downloads = NULL;
gboolean keep_going = TRUE;
GThreadPool* g_threadpool = NULL;
GdkCursor *cursor;
GHashTable* hashinfo = NULL;

const gchar* statusdescriptions[] = {
	"Queued",
	"Downloading",
	"Finished"
};

const gchar *porntypes[]={"Sticky Movies", \
			  "Celebrities", \
			  "Teens", \
			  "Hardcore", \
			  "Tits", \
			  "Milf", \
			  "Pornstars", \
			  "Lesbian", \
			  "Public Exposure", \
			  "Babes", \
			  "Ethnic", \
			  "Amateur", \
			  "Potpourri", \
			  "Gay", \
			  "Trannie"};

const gchar *pageurls[] = {"www.sublimedirectory.com/movies", \
			   "www.sublimedirectory.com/celebs", \
			   "www.sublimedirectory.com/teen", \
			   "www.sublimedirectory.com/hardcore", \
			   "www.sublimedirectory.com/tits", \
			   "www.sublimedirectory.com/milf", \
			   "www.sublimedirectory.com/pornstars", \
			   "www.sublimedirectory.com/lesbian", \
			   "www.sublimedirectory.com/flashing", \
			   "www.sublimedirectory.com/babes", \
			   "www.sublimedirectory.com/ethnic", \
			   "www.sublimedirectory.com/amateur", \
			   "www.sublimedirectory.com/potpourri", \
			   "www.sublimedirectory.com/gay", \
			   "www.sublimedirectory.com/trannie"};

GList *alllinks[NUMPORNTYPES] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

G_LOCK_DEFINE_STATIC(alllinks);
G_LOCK_DEFINE_STATIC(cursor);

gchar *gnaughty_build_download_filename(gchar *pattern, gchar *basedir, gchar *absurl)
{

	gchar* path = g_build_filename(pattern, gnaughty_urls_separate_link_hostname(absurl)[0]->str, gnaughty_urls_separate_link_filename(absurl)[1]->str, NULL);

	//g_string_append(path, gnaughty_urls_separate_link_hostname(absurl)[0]->str);

	//g_string_append(path, G_DIR_SEPARATOR_S);

	//add the filename at the end
	//g_string_append(path, gnaughty_urls_separate_link_filename(absurl)[1]->str);
	
	#ifdef WIN32
	//g_string_append(path, "\"");
	#endif
	
	return path;
}

void gnaughty_remove_finished_downloads()
{
	int i;
	puts("removing");
	for (i = g_list_length(g_downloads) - 1 ; i >= 0 ; i--) {
		download_t* download = NULL;
		download = (download_t*)g_list_nth_data(g_downloads, i);
		if (download->status == STATUS_FINISHED) {
			gnaughty_gui_remove_download(download);
			g_downloads = g_list_remove(g_downloads, download);
			free(download);
		}
	}
}

gint sort_func_pages (gpointer data1, gpointer data2)
{
	gchar *d1, *d2;
	d1 = data1 + (strlen(data1) - 5);
	d2 = data2 + (strlen(data2) - 5); 
	
	return strcmp (d1, d2) * -1;
}

typedef struct {
	GList* PagesWithLinks;
	gboolean movies;
} links_to_download_arguments_t;

/**
 *
 * @param PagesWithLinks GList of gchar*'s to pages with links in them
 * @param movies when true, search for movie links (.mpg, .avi, ...), otherwise
 * search for pictures
 * @return Returns a Glist* with *'s to GStrings that contains absolute urls of
 * pictures or movies to be downloaded.
 */
gpointer gnaughty_get_links_to_download(gpointer data)
{
	GList* iterator;
	GString* currentpage = NULL;
	GString* linkpath = NULL;
	GList* LinksToDownload=NULL;
	gint oldlen = 0;
	gchar* trun= NULL;
	GString* final_url;

	links_to_download_arguments_t* args = (links_to_download_arguments_t*)data;
	G_LOCK_DEFINE_STATIC(args);
	//convert each URL to an absolute GString, free the old gchar
	G_LOCK(args);

	//Sort list so that Pictures pages are download before Movies pages
	args->PagesWithLinks = g_list_sort (args->PagesWithLinks, (GCompareFunc) sort_func_pages);

	for(iterator = args->PagesWithLinks ; iterator != NULL ; iterator = iterator->next)
	{
		gchar* tmpdata;
		tmpdata = iterator->data;
		iterator->data = gnaughty_urls_absolute_link(tmpdata, "www.sublimedirectory.com");
		g_free(tmpdata);
	}

	//for each url, retrieve list of movie links and add to master list
	for(iterator = args->PagesWithLinks ; iterator != NULL ; iterator = iterator->next)
	{
		GString *mistring = (GString *)(iterator->data);
		trun = mistring->str + (mistring->len - 5);
		if (strcmp(trun,"/MOV/")==0) {
			args->movies = TRUE;
		} else {
			args->movies = FALSE;
		}
		g_string_truncate (mistring, mistring->len - 5);
		iterator->data = (gpointer*) mistring;

		g_idle_add(gnaughty_set_download_status, g_strdup_printf("Querying server - %s", ((GString *)(iterator->data))->str));
		final_url = g_string_new ("");
		currentpage = getfile(((GString *)(iterator->data))->str, final_url);

		linkpath = gnaughty_urls_separate_link_filename(final_url->str)[0];

		if(args->movies)
			LinksToDownload = get_links_from_page(LinksToDownload, currentpage, linkpath, TRUE);
		else
			LinksToDownload = get_links_from_page(LinksToDownload, currentpage, linkpath, FALSE);

		if(g_list_length(LinksToDownload) == oldlen)
		{
			printf("No valid links found on %s\n", ((GString *)(iterator->data))->str);
			g_string_free(linkpath, TRUE);
			g_string_free(currentpage, TRUE);
			g_string_free(iterator->data, TRUE);
			g_string_free (final_url, TRUE);
			continue;
		}
		oldlen = g_list_length(LinksToDownload);
		g_string_free(iterator->data, TRUE);
		g_string_free(linkpath, TRUE);
		g_string_free(currentpage, TRUE);
		g_string_free (final_url, TRUE);
	}

	g_idle_add(gnaughty_set_download_status, g_strdup("All servers queried..."));
	G_UNLOCK(args);

	//we're now done with PagesWithLinks, and everything in it should have been freed
	g_list_free(args->PagesWithLinks);
	free(data);

	//args->gnaughty_links_download_finished(LinksToDownload);
	g_idle_add(gnaughty_links_download_finished, LinksToDownload);
	return NULL;
}

/**
 * 
 * @param LocalFileNames A GList of char*'s to the local filenames.
 * @param movies When true, movies will be played, otherwise pictures will be shown.
 */
void gnaughty_show_downloaded_files(GList* LocalFileNames, gboolean movies)
{
	if(0)
	{
	if(movies)
	{
		if(g_prefs.playafterdl)
		{
			gint response;
			GtkWidget* dialog = gtk_message_dialog_new (GTK_WINDOW(glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwin")), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "Download completed. Shall I play the downloaded movies?");
			gtk_dialog_add_button(GTK_DIALOG(dialog), GTK_STOCK_CANCEL, GTK_RESPONSE_NO);
			gtk_widget_grab_focus(gtk_dialog_add_button(GTK_DIALOG(dialog), "Play", GTK_RESPONSE_YES));
			response = gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);

			if(response == GTK_RESPONSE_YES)
			{
				gnaughty_play_movies(LocalFileNames);
				if(g_prefs.deleteafterplay)
					gnaughty_delete_files(LocalFileNames);
			}
		}
	} else {
		if(g_prefs.showafterdl) {
			gint response;
			GtkWidget* dialog = gtk_message_dialog_new (GTK_WINDOW(glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwin")), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "Download completed. Shall I show the downloaded pictures?");
			gtk_dialog_add_button(GTK_DIALOG(dialog), "Cancel", GTK_RESPONSE_NO);
			gtk_widget_grab_focus(gtk_dialog_add_button(GTK_DIALOG(dialog), "Show", GTK_RESPONSE_YES));
			response = gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
			
			if(response == GTK_RESPONSE_YES) {
				gnaughty_play_pictures(LocalFileNames);
				if(g_prefs.deleteafterplay)
					gnaughty_delete_files(LocalFileNames);
			}
		}
	}
	}
}

void gnaughty_download_movies()
{
	GList* PagesWithLinks=NULL;
	GError* error;
	links_to_download_arguments_t* args;
	args = malloc(sizeof(links_to_download_arguments_t));

	gboolean movies = FALSE;

	movies = gnaughty_gui_is_movies_selected();

	// retrieve the selected URL's
	PagesWithLinks = gnaughty_gui_get_selected_urls();

	// if list is empty
	if(PagesWithLinks == NULL)
	{
		g_print("No links selected, aborting download.\n");
		return;
	}

	//printf("GThreadfunc in main program: %p\n", g_thread_self()->func);
	//printf("gnaughty_download_movies in main program: %p\n", gnaughty_download_movies);

	// Get the links from the selected pages in a separate thread
	args->PagesWithLinks = PagesWithLinks;
	args->movies = movies;
	g_thread_create(gnaughty_get_links_to_download, args, TRUE, &error);
}

gboolean gnaughty_set_download_status(gpointer data)
{
	gnaughty_gui_set_download_status((char*)data);
	return FALSE;
}

gboolean gnaughty_links_download_finished(gpointer data)
{
	GList* iterator;
	GList* LocalFileNames = NULL;
	gint NumberOfLinks = 0;
	gint LinksRetrieved = 0;

	GList* LinksToDownload = (GList*)data;

	//printf("GThreadfunc after returning: %p\n", g_thread_self()->func);
	//printf("gnaughty_download_movies after returning: %p\n", gnaughty_download_movies);

	gboolean movies = FALSE;
	movies = gnaughty_gui_is_movies_selected();

	NumberOfLinks = g_list_length(LinksToDownload);

	// Add all links to the downloads list
	gnaughty_gui_add_links_to_download_list(LinksToDownload);

	// Add these new downloads to the global downloads list
	g_downloads = g_list_concat(g_downloads, g_list_copy(LinksToDownload));

	if(LinksToDownload == NULL)
	{
		puts("There seem to be no valid links in any of the pages you selected, how sad.");
		return FALSE;
	}

	//download everything in list
	for(iterator = LinksToDownload ; iterator != NULL ; iterator = iterator->next)
	{
		download_t* current_download = (download_t*)(iterator->data);
		if(keep_going) {
			char *path, *filename, *extension;
			int i = 1;
			download_progress* progress = malloc(sizeof(download_progress));
			GString** name = gnaughty_urls_separate_link_filename(current_download->URL->str);
			GString** hostname = gnaughty_urls_separate_link_hostname(current_download->URL->str);

			progress->TotalMovies = NumberOfLinks;
			progress->ThisMovie = LinksRetrieved;
//printf("links retrieved: %d\n", LinksRetrieved);
			//gnaughty_set_download_status(g_strdup_printf("Downloading item %d of %d...", ++LinksRetrieved, NumberOfLinks));

			// Test is file already exists; if so, generate other name
			filename = g_strdup(name[1]->str);
			path = g_build_filename (g_prefs.downloadpattern, hostname[0]->str, current_download->subfolder, filename, NULL);
			extension = strrchr(filename, '.');
			if (extension) {
				*extension++ = 0;
			}
			while (g_file_test(path, G_FILE_TEST_EXISTS)) {
				char *newname;

				newname = g_strdup_printf(extension ? "%s(%d).%s" : "%s(%d)", filename, i++, extension);
				g_free(path);
				path = g_build_filename(g_prefs.downloadpattern, hostname[0]->str, current_download->subfolder, newname, NULL);

				g_free(newname);
			}

			g_free(filename);
			gnaughty_urls_free_pair(name);
			gnaughty_urls_free_pair(hostname);

			LocalFileNames = g_list_append(LocalFileNames, path);

			// Spawn download into separate thread
			download_args_t* args = (download_args_t*)malloc(sizeof(args));
			args->download = current_download;
			args->path = path;
			g_thread_pool_push(g_threadpool, args, NULL);

			g_free(progress);
		} else {
			g_list_free(LinksToDownload);
			g_list_foreach(LocalFileNames, (GFunc)g_free, NULL);
			g_list_free(LocalFileNames);
			keep_going = TRUE;
			return FALSE;
		}
	}

	return FALSE;
}

void gnaughty_do_download(gpointer data, gpointer user_data)
{
	download_args_t* args = (download_args_t*)data;

	if (hashinfo == NULL) {
		hashinfo = g_hash_table_new_full (g_str_hash,g_str_equal,g_free,g_free);
	}
	g_hash_table_insert (hashinfo, g_strdup(args->download->URL->str), g_strdup(args->path));

	download(args->download, args->path);

	g_idle_add(gnaughty_download_finished, NULL);
}

int compare_func2 (gconstpointer data, gconstpointer p)
{
	if (((download_t *) data)->status != STATUS_FINISHED) {
		return 0;
	}
		
	return 1;
}

gboolean gnaughty_download_finished(gpointer data)
{
//printf("hi - %d\n", g_list_length(g_downloads));
	if (g_list_find_custom (g_downloads, NULL, compare_func2) == NULL) {
		gnaughty_set_download_status(g_strdup ("All downloads finished"));
		// After download
		//gnaughty_show_downloaded_files(LocalFileNames, movies);
	}

	return FALSE;

/*
#ifndef WIN32
			if(prefs.deleteinvalid)
			{
				if(!ismovie(g_list_last(LocalFileNames)->data))
				{
					g_print("%s isn't a valid media file ... deleting it\n", g_list_last(LocalFileNames)->data);
					remove(g_list_last(LocalFileNames)->data);
				}
			}
#endif
			*/

	// if all downloads finished, clean up...
	//gnaughty_gui_set_download_progress(GnaughtyXML, 1.0);
	//gnaughty_gui_set_download_status(GnaughtyXML, "Downloads completed.");
	//gtk_widget_hide_all(glade_xml_get_widget(GnaughtyXML, "download_window"));
	//if ( ) {

	//}

	//clean up

	//g_list_free(LinksToDownload);



	//g_list_foreach(LocalFileNames, (GFunc)g_free, NULL);
	//g_list_free(LocalFileNames);

	//return FALSE;
}

void gnaughty_fill_movie_list(gint type)
{
	if(alllinks[type] == NULL) {
		g_thread_create(gnaughty_download_and_process_index_page, (gpointer)type, FALSE, NULL);
	} else {
		gnaughty_index_download_finished((gpointer)type);
	}
}

/**
 * Run in separate thread.
 */
gpointer gnaughty_download_and_process_index_page(gpointer data)
{
	GString* LinksPage;
	GString* download_status;
	gint type = (gint)data;
	GString* final_url;

	gdk_threads_enter ();
	cursor = gdk_cursor_new(GDK_WATCH);
	gdk_window_set_cursor(GDK_WINDOW(GTK_WIDGET(glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwindow"))->window), cursor);
	gdk_threads_leave ();
	
	download_status = g_string_new("");
	g_string_printf(download_status, "Downloading page %s", pageurls[type]);
	g_idle_add(gnaughty_set_download_status, g_strdup(download_status->str));

	final_url = g_string_new ("");
	LinksPage = getfile(pageurls[type], final_url);
	g_string_free (final_url, TRUE); //final_url not needed here
	if(strcmp(LinksPage->str, "") == 0) {
		g_string_free(LinksPage, TRUE);
		g_string_free (download_status, TRUE);
		puts("There seems to be a problem retrieving the index.");
		return NULL;
	}
	if ( (LinksPage = cutsublimepage(LinksPage)) == NULL) {
		g_string_free (download_status, TRUE);
		puts("There seems to be a problem cutting the index.");
		return NULL;
	}
	G_LOCK(alllinks);
	alllinks[type] = getsublimelinks(LinksPage);
	G_UNLOCK(alllinks);
	g_string_free(LinksPage, TRUE);
	
	
	
	g_string_printf(download_status, "Finished downloading page %s", pageurls[type]);
	g_idle_add(gnaughty_set_download_status, download_status->str);

	g_idle_add(gnaughty_index_download_finished, (gpointer)type);

	g_string_free (download_status, FALSE);
	return NULL;
}

gboolean gnaughty_index_download_finished(gpointer data)
{
	GList* iterator;
	gint type = (gint)data;

	G_LOCK(alllinks);
	for(iterator = alllinks[type] ; iterator != NULL ; iterator = iterator->next)
	{
		gnaughty_gui_add_movie_list_item((link_t*)iterator->data);
	}
	G_UNLOCK(alllinks);
	
	G_LOCK(cursor);
	gdk_cursor_unref(cursor);
	cursor = gdk_cursor_new(GDK_LEFT_PTR);
	gdk_window_set_cursor(GDK_WINDOW(GTK_WIDGET(glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwindow"))->window), cursor);
    G_UNLOCK(cursor);
	
	return FALSE;
}

void gnaughty_init_config(int argc, char *argv[])
{
#ifdef WIN32
	RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\gnaughty", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &key, NULL);
#else
	GError* err = NULL;

	if (!gconf_init(argc, argv, &err))
	{
		fprintf(stderr, "Failed to init GConf: %s\n", err->message);
		g_error_free(err); 
		err = NULL;
		exit(1);
	}

	key = gconf_client_get_default();
	gconf_client_add_dir(key, prefbase, GCONF_CLIENT_PRELOAD_NONE, NULL);
	gconf_client_notify_add (key, prefbase, update_prefs, &g_prefs, NULL, NULL);
#endif
	return;
}

void get_options(int argc, char *argv[])
{
    int i;
    char *arg;

    for (i = 1; i < argc; i++) {
        arg = argv[i];

        if (strcmp(arg, "-v") == 0 ||
            strcmp(arg, "--version") == 0) {
            char *prg;
            prg = g_path_get_basename(argv[0]);
            printf("%s %s \n",prg, VERSION);
            g_free(prg);
            exit(0);
        }
    }
}

int main(int argc, char *argv[])
{
	get_options(argc, argv);

	//initialize gtk
	g_thread_init(NULL);
	gdk_threads_init();
	gtk_init(&argc, &argv);
	glade_init();

	//inititalize curl
	curl_global_init(CURL_GLOBAL_ALL);

	//initialize gconf
	gnaughty_init_config(argc, argv);

	//initialize prefs
	gnaughty_prefs_get(key);

	// Initialize the thread pool
	g_threadpool = g_thread_pool_new(gnaughty_do_download, NULL, g_prefs.nr_downloads, FALSE, NULL);

	//create windows
	GnaughtyXML = gnaughty_gui_new_mainwin(key);

	//show main window
	gtk_widget_show_all(GTK_WIDGET(glade_xml_get_widget(GnaughtyXML, "gnaughty_mainwindow")));

	//fill list with movie links
	gnaughty_fill_movie_list(MOVIEENTRY);

	gdk_threads_enter();
	gtk_main();
	gdk_threads_leave();

	return 0;
}
// vim:noexpandtab:ts=4 sw=4:
