#include "prefs.h"
#include <stdio.h>

extern GnaughtyPrefs g_prefs;

#ifdef WIN32
gboolean gnaughty_pref_get_bool(gnaughty_config key, gchar *pref)
{
    gboolean result;
    DWORD datasize=sizeof(gboolean);
    RegQueryValueEx(key, pref, NULL, NULL, (BYTE*)&result, &datasize);
    return result;
}

gint gnaughty_pref_get_int(gnaughty_config key, gchar *pref)
{
    gint result=0;
    DWORD datasize=sizeof(int);
    RegQueryValueEx(key, pref, NULL, NULL, (BYTE*)&result, &datasize);
    return result;
}

gchar *gnaughty_pref_get_string(gnaughty_config key, gchar *pref)
{
    DWORD size=255;
    gchar *result = g_malloc(255);
    if( (RegQueryValueEx(key, pref, NULL, NULL, (BYTE*)result, &size)) ==0)
    {
        return result;
    }
    else
    {
        return NULL;
    }

    return NULL;
}
GnaughtyPrefs defaultprefs = {"", FALSE, "", 0, TRUE, FALSE, FALSE, "\"C:\\Program Files\\Windows Media Player\\wmplayer.exe\"", "\"\""};
#else
GnaughtyPrefs defaultprefs = {"", FALSE, "", 0, TRUE, FALSE, FALSE, "mplayer -fs", "animate -delay 500", 3, TRUE};
#endif

GnaughtyPrefs DefaultPrefs()
{
	//GnaughtyPrefs* prefs = g_new(GnaughtyPrefs, 1);
	GString* dlpattern;
	gchar *a = NULL;
	dlpattern = g_string_new(g_get_home_dir());
#ifdef WIN32
	if (strcmp(dlpattern->str, "") != NULL)
		g_string_append(dlpattern, g_strconcat(G_DIR_SEPARATOR_S, "My Documents\\Porn", NULL));
	else
		g_string_append(dlpattern, "C:\\Porn\\");
#else
	a = g_strconcat(G_DIR_SEPARATOR_S, "porn", NULL);
	g_string_append(dlpattern, a);
	g_free (a);
#endif
	defaultprefs.downloadpattern = dlpattern->str;
	
	g_string_free(dlpattern, FALSE);

	return defaultprefs;
}

/**
 * Checks if there are prefs stored. If not, set some defaults. If they are,
 * read them in. All results are stored in g_prefs.
 */
void gnaughty_prefs_get(gnaughty_config key)
{
	gchar *a = NULL;
	g_prefs.downloadpattern = gnaughty_pref_get_string(key, g_strconcat(prefbase, "/download_pattern", NULL));
	if(g_prefs.downloadpattern == NULL || g_prefs.downloadpattern[0] == '\0') {
		g_print("Setting default preferences...\n");
		DefaultPrefs();
		g_prefs = defaultprefs;
		gnaughty_prefs_set(&g_prefs, key);
		return;
	}

	g_prefs.proxyurl = gnaughty_pref_get_string(key, g_strconcat("/system/http_proxy/host", NULL));
	if(g_prefs.proxyurl==NULL)
	{
		g_prefs.useproxy = defaultprefs.useproxy;
		g_prefs.proxyurl = defaultprefs.proxyurl;
		g_prefs.proxyport = defaultprefs.proxyport;
	}

	g_prefs.useproxy=gnaughty_pref_get_bool(key, g_strconcat("/system/http_proxy/use_http_proxy", NULL));
	g_prefs.proxyport=gnaughty_pref_get_int(key, g_strconcat("/system/http_proxy/port", NULL));
	g_prefs.playafterdl=gnaughty_pref_get_bool(key, g_strconcat(prefbase, "/play_after_download", NULL));
	g_prefs.showafterdl=gnaughty_pref_get_bool(key, g_strconcat(prefbase, "/show_after_download", NULL));
	g_prefs.deleteafterplay=gnaughty_pref_get_bool(key, g_strconcat(prefbase, "/delete_after_play", NULL));
#ifndef WIN32
	g_prefs.deleteinvalid=gnaughty_pref_get_bool(key, g_strconcat(prefbase, "/delete_invalid", NULL));
#endif

	g_prefs.playcommand=gnaughty_pref_get_string(key, g_strconcat(prefbase, "/play_command", NULL));
	if(g_prefs.playcommand==NULL)
	{
		g_prefs.playcommand=defaultprefs.playcommand;
	}

	g_prefs.playpiccommand=gnaughty_pref_get_string(key, g_strconcat(prefbase, "/play_picture_command", NULL));
	if(g_prefs.playpiccommand==NULL)
	{
		g_prefs.playpiccommand=defaultprefs.playpiccommand;
	}

	g_prefs.nr_downloads=gnaughty_pref_get_int(key, g_strconcat(prefbase, "/nr_downloads", NULL));

	return;
}

void gnaughty_prefs_set(GnaughtyPrefs* prefs, gnaughty_config key)
{
	g_assert(key);
	gchar *a = NULL;
	gnaughty_pref_set_string(key, g_strconcat(prefbase, "/download_pattern", NULL), g_prefs.downloadpattern);
	gnaughty_pref_set_bool(key, g_strconcat("/system/http_proxy/use_http_proxy", NULL), g_prefs.useproxy);
	gnaughty_pref_set_string(key, g_strconcat("/system/http_proxy/host", NULL), g_prefs.proxyurl);
	gnaughty_pref_set_int(key, g_strconcat("/system/http_proxy/port", NULL), g_prefs.proxyport);
	gnaughty_pref_set_bool(key, g_strconcat(prefbase, "/show_after_download", NULL), g_prefs.showafterdl);
	gnaughty_pref_set_bool(key, g_strconcat(prefbase, "/play_after_download", NULL), g_prefs.playafterdl);
	gnaughty_pref_set_bool(key, g_strconcat(prefbase, "/delete_after_play", NULL), g_prefs.deleteafterplay);
	gnaughty_pref_set_string(key, g_strconcat(prefbase, "/play_command", NULL), g_prefs.playcommand);
	gnaughty_pref_set_string(key, g_strconcat(prefbase, "/play_picture_command", NULL), g_prefs.playpiccommand);
	gnaughty_pref_set_int(key, g_strconcat(prefbase, "/nr_downloads", NULL), g_prefs.nr_downloads);

#ifndef WIN32
    gnaughty_pref_set_bool(key, g_strconcat(prefbase, "/delete_invalid", NULL), g_prefs.deleteinvalid);
#endif
}

void dump_prefs(GnaughtyPrefs* prefs)
{
    printf("download_pattern = %s\nuse_proxy = %d\nproxy_url = %s\nproxy_port = %d\nshow_after_download = %d\nplay_after_download = %d\ndelete_after_play = %d\nplay_command = %s\nplay_picture_command = %s \n"\
    , prefs->downloadpattern \
    , prefs->useproxy \
    , prefs->proxyurl \
    , prefs->proxyport \
    , prefs->showafterdl \
    , prefs->playafterdl \
    , prefs->deleteafterplay \
    , prefs->playcommand \
    , prefs->playpiccommand \
    );
}
// vim:noexpandtab:ts=4 sw=4:
