/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/
#ifndef PREFS_H
#define PREFS_H
#ifdef WIN32
    #include <windows.h>
#else
    #include <gconf/gconf-client.h>
#endif
#include <glib.h>

typedef struct {
	gchar* downloadpattern;
	gboolean useproxy;
	gchar* proxyurl;
	gint proxyport;
	gboolean playafterdl;
	gboolean showafterdl;
	gboolean deleteafterplay;
	gchar* playcommand;
	gchar* playpiccommand;
	gint nr_downloads;
#ifndef WIN32
	gboolean deleteinvalid;
#endif
} GnaughtyPrefs;

#ifdef WIN32
typedef HKEY gnaughty_config;
#define prefbase ""
#else
typedef GConfClient *gnaughty_config;
#define prefbase "/apps/gnaughty"
#endif

#ifdef WIN32

gboolean gnaughty_pref_get_bool(gnaughty_config key, gchar *pref);
gint gnaughty_pref_get_int(gnaughty_config key, gchar *pref);
gchar *gnaughty_pref_get_string(gnaughty_config key, gchar *pref);

#define gnaughty_pref_set_bool(key, pref, value) RegSetValueEx(key, pref, 0, REG_DWORD, (LPBYTE)&value, sizeof(int))
#define gnaughty_pref_set_int(key, pref, value) RegSetValueEx(key, pref, 0, REG_DWORD, (LPBYTE)&value, sizeof(int))
#define gnaughty_pref_set_string(key, pref, value) RegSetValueEx(key, pref, 0, REG_SZ, (LPBYTE)value, strlen(value)+1)
#else
#define gnaughty_pref_get_bool(key, pref) gconf_client_get_bool(key, a = pref, NULL);\
g_free (a)
#define gnaughty_pref_get_int(key, pref) gconf_client_get_int(key, a = pref, NULL);\
g_free (a)
#define gnaughty_pref_get_string(key, pref) gconf_client_get_string(key, a = pref, NULL);\
g_free (a)

#define gnaughty_pref_set_bool(key, pref, value) gconf_client_set_bool(key, a = pref, value, NULL), g_free (a)
#define gnaughty_pref_set_int(key, pref, value) gconf_client_set_int(key, a = pref, value, NULL), g_free (a)
#define gnaughty_pref_set_string(key, pref, value) gconf_client_set_string(key, a = pref, value, NULL), g_free (a)
#endif

void gnaughty_prefs_get(gnaughty_config key);
void gnaughty_prefs_set(GnaughtyPrefs *prefs, gnaughty_config key);
void dump_prefs(GnaughtyPrefs *prefs);

#endif
// vim:noexpandtab:ts=4 sw=4:
